﻿using System;
using System.Configuration;
using System.Data.SqlClient;

namespace PBX_Database
{
    class DatabaseManager
    {
        string _connectionString;
        SqlConnection _connection;

        public DatabaseManager()
        {
            InitializeDBManager();
            OpenConnection();
        }

        void InitializeDBManager()
        {
            _connectionString = ConfigurationManager.ConnectionStrings["MyConnectionString"].ConnectionString;
            _connection = new SqlConnection(_connectionString);
        }

        void OpenConnection()
        {
            Console.WriteLine("Connecting to database...\n");
            try
            {
                _connection.Open();
                Console.WriteLine("Database connected.\n");
            }
            catch (Exception ex)
            {
                Console.WriteLine("Error during connecting: {0}", ex.Message);
            }
        }

        bool ContainsKey(string username)
        {
            using (var command = _connection.CreateCommand())
            {
                command.CommandText = "SELECT * FROM Table_AllowedUsers WHERE Username = '" + username + "'";

                using (var reader = command.ExecuteReader())
                {
                    if (reader.HasRows)
                        return true;
                }
            }
            return false;
        }

        public void AddUserInfo(UserInfo userInfo)
        {
            using (var command = _connection.CreateCommand())
            {
                if (!ContainsKey(userInfo.UserName))
                {
                    command.CommandText = "INSERT INTO Table_AllowedUsers (Username, Password) values ('" + userInfo.UserName +
                                          "', '" + userInfo.Password + "')";
                    command.ExecuteNonQuery();
                }
                else
                    Console.WriteLine("Already inserted.");
            }
        }

        public bool TryGetUserInfo(string username)
        {
            using (var command = _connection.CreateCommand())
            {
                command.CommandText = "SELECT * FROM Table_AllowedUsers WHERE Username = '" + username + "'";

                using (var reader = command.ExecuteReader())
                {
                    if (reader.HasRows)
                        return true;
                }
            }
            return false;
        }

        public UserInfo GetUserInfo(string username)
        {
            using (var command = _connection.CreateCommand())
            {
                command.CommandText = "SELECT * FROM Table_AllowedUsers WHERE Username = '" + username + "'";

                using (var reader = command.ExecuteReader())
                {
                    if (reader.HasRows)
                    {
                        reader.Read();
                        var password = reader["Password"].ToString();
                        UserInfo userInfo = new UserInfo(username, password);
                        return userInfo;
                    }
                }
            }
            Console.WriteLine("Can not find user.");
            return null;
        }

    }
}
